//+------------------------------------------------------------------+
//|                                     TrailingStop Percentage EA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int tp = 10; // min takeprofit to begin ts
extern double tp_percentage = 50.0; // percentage to trail, from 0 to 100
extern int tp_max = 50; // max takeprofit to end ts

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
        int i;
        double currency_point;
        double in_profit;
        double sl;
        for (i=OrdersTotal()-1;i>=0;i--)
        {
                if (OrderSelect(i,SELECT_BY_POS) == true )
                {
                        if (StringFind(OrderSymbol(),"JPY") >=0)
                        {
                                currency_point =  0.01;                
                        }
                        else
                        {
                                currency_point = 0.0001;
                        }
                        if (OrderType() == OP_BUY)
                        {
                                if (MarketInfo(OrderSymbol(),MODE_BID) >= OrderOpenPrice() + tp*currency_point)
                                {                                        
                                        
                                   if ( tp_max > 0 && (MarketInfo(OrderSymbol(),MODE_BID) - OrderOpenPrice())/currency_point > tp_max) sl = OrderOpenPrice() + tp_max*currency_point;
                                   else sl = OrderOpenPrice() + (MarketInfo(OrderSymbol(),MODE_BID) - OrderOpenPrice())*tp_percentage/100;
                                   if (sl <= MarketInfo(OrderSymbol(),MODE_BID)-MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(),MODE_POINT) && ((OrderStopLoss() == 0) || OrderStopLoss() < sl)) OrderModify(OrderTicket(),OrderOpenPrice(),sl,0,0);
                                }
                        }
                        else if (OrderType() == OP_SELL)
                        {
                                if (MarketInfo(OrderSymbol(),MODE_ASK) <= OrderOpenPrice() - tp*currency_point)
                                {                                                                                
                                   if ( tp_max > 0 && (OrderOpenPrice() - MarketInfo(OrderSymbol(),MODE_ASK))/currency_point > tp_max) sl = OrderOpenPrice() - tp_max*currency_point;
                                   else sl = OrderOpenPrice() - (OrderOpenPrice() - MarketInfo(OrderSymbol(),MODE_ASK))*tp_percentage/100;
                                   if (sl >= MarketInfo(OrderSymbol(),MODE_ASK)+MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(),MODE_POINT) && ((OrderStopLoss() == 0) || OrderStopLoss() < sl)) OrderModify(OrderTicket(),OrderOpenPrice(),sl,0,0);
                                }                        
                        }
                }                
        }
//----
   return(0);
  }
//+------------------------------------------------------------------+